SystemOrganization addCategory: #'Statsd-Core'!

Object subclass: #Statsd
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statsd-Core'!

Statsd class
	instanceVariableNames: 'default randomNumberGenerator'!

!Statsd commentStamp: 'PaulDeBruicker 9/6/2012 07:26' prior: 0!
Sends data counters, gauges, and timing info to statsd via UDP

https://github.com/etsy/statsd

Data from statsd can then be graphed with graphite for use in a dashboard or something like that
http://graphite.wikidot.com/

Its best to hardcode the ip address of the statsd server as a SocketAddress or ByteArray in #hostAddress to save the DNS lookup.  

!

Statsd class
	instanceVariableNames: 'default randomNumberGenerator'!

!Statsd class methodsFor: 'increment-decrement' stamp: 'PaulDeBruicker 9/6/2012 06:44'!
decrement: aDataItem
	self decrement: aDataItem withSampling: 1! !

!Statsd class methodsFor: 'increment-decrement' stamp: 'PaulDeBruicker 9/6/2012 07:09'!
decrement: aDataItem withSampling: aFrequency
	"aFrequency of 0.1 means its only sent every 10 times the Frequency should be between 0.0 and 1.0 "
"
100 timesRepeat:[Statsd decrement: 'testStat' withSampling: 0.6.]
"
	self default send: aDataItem , ':-1|c' withSampling: aFrequency! !

!Statsd class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/5/2012 15:39'!
default
	^ default ifNil: [ self initializeStatsdDefault ]! !

!Statsd class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/5/2012 16:30'!
defaultHost
	^ 'localhost'! !

!Statsd class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/5/2012 15:04'!
defaultPort
	^ 8125! !

!Statsd class methodsFor: 'increment-decrement' stamp: 'PaulDeBruicker 9/6/2012 06:45'!
increment: aDataItem
	self increment: aDataItem withSampling: 1! !

!Statsd class methodsFor: 'increment-decrement' stamp: 'PaulDeBruicker 9/6/2012 07:08'!
increment: aDataItem withSampling: aFrequency
	"aFrequency of 0.1 means its only sent every 10 times the Frequency should be between 0.0 and 1.0 "
"
100 timesRepeat:[Statsd increment: 'testStat' withSampling: 0.3.]

"
	self default send: aDataItem , ':1|c' withSampling: aFrequency  ! !

!Statsd class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/6/2012 07:12'!
initializeRandomNumberGenerator
	 randomNumberGenerator := Random new.
	^randomNumberGenerator ! !

!Statsd class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/6/2012 07:11'!
initializeStatsdDefault
	"
Statsd initializeStatsdDefault
"
	
	default := self basicNew initialize.
	self initializeRandomNumberGenerator .
	^ default! !

!Statsd class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/5/2012 14:59'!
new
	^ self default! !

!Statsd class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/6/2012 07:11'!
randomNumberGenerator
	^ randomNumberGenerator ifNil: [ self initializeRandomNumberGenerator ]! !

!Statsd class methodsFor: 'timing' stamp: 'PaulDeBruicker 9/6/2012 07:04'!
recordTimingFor: aDataItemString of: aNumberOfMilliseconds
"
Statsd recordTimingFor:'timingTest' of: [[1 << 3] bench] timeToRun
"



	self default send: aDataItemString , ':' , aNumberOfMilliseconds asString , '|ms' withSampling: 1! !

!Statsd class methodsFor: 'gauge' stamp: 'PaulDeBruicker 9/6/2012 07:00'!
setGauge: aDataItemString to: aNumber
"
Statsd setGauge:'numberOfLoggedInUsers' to: 47

"


	self default send: aDataItemString , ':' , aNumber asString , '|g' withSampling:1! !

!Statsd methodsFor: 'socket' stamp: 'PaulDeBruicker 9/5/2012 15:06'!
host
	^ self class defaultHost! !

!Statsd methodsFor: 'socket' stamp: 'PaulDeBruicker 9/5/2012 20:13'!
hostAddress
	"^ NetNameResolver addressForName: self host"

	^NetNameResolver localHostAddress ! !

!Statsd methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 9/5/2012 16:37'!
initialize
	super initialize.
	self initializeUDPSocket! !

!Statsd methodsFor: 'socket' stamp: 'PaulDeBruicker 2/20/2013 14:26'!
initializeUDPSocket
	self socket: self newUdpSocket! !

!Statsd methodsFor: 'socket' stamp: 'PaulDeBruicker 2/20/2013 14:26'!
newUdpSocket
	^ self socketClass newUDP! !

!Statsd methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/5/2012 15:31'!
nextRandomNumber
	^ self class randomNumberGenerator next! !

!Statsd methodsFor: 'socket' stamp: 'PaulDeBruicker 9/5/2012 15:06'!
port
	^ self class defaultPort! !

!Statsd methodsFor: 'socket' stamp: 'PaulDeBruicker 2/20/2013 14:26'!
send: stringToSend
	"from Goran Krampe's  SimpleLog may be more reliable than using the primitive.  "

	| sock |
	sock := self newUdpSocket.
	sock setPeer: NetNameResolver localHostAddress port: self port.
	sock sendData: stringToSend.
	sock waitForSendDoneFor: self socketClass standardDeadline.
	sock close! !

!Statsd methodsFor: 'socket' stamp: 'PaulDeBruicker 9/5/2012 19:39'!
send: aString withSampling: aFrequency
	| send stringToSend |
	send := aFrequency < 1
		ifTrue: [ 
			self nextRandomNumber <= aFrequency
				ifTrue: [ 
					stringToSend := aString , '|@' , aFrequency asString.
					true ]
				ifFalse: [ false ] ]
		ifFalse: [ 
			stringToSend := aString.
			true ].
	send
		ifTrue: [ self sendUDPPrimitive: stringToSend ]! !

!Statsd methodsFor: 'socket' stamp: 'PaulDeBruicker 9/5/2012 19:30'!
sendUDPPrimitive: stringToSend
	self socket sendUDPData: stringToSend toHost: self hostAddress port: self port! !

!Statsd methodsFor: 'accessing' stamp: 'PaulDeBruicker 9/5/2012 16:37'!
socket
	^ socket! !

!Statsd methodsFor: 'accessing' stamp: 'PaulDeBruicker 9/5/2012 16:37'!
socket: anObject
	socket := anObject! !

!Statsd methodsFor: 'socket' stamp: 'PaulDeBruicker 2/20/2013 14:26'!
socketClass
	^ Socket! !
